%define version 3.2
%define release 3mdk
%define rhrelease 1
%define extpatch .chmou

Name: MAKEDEV
Version: %{version}
Release: %{release}
Group: System/Kernel and hardware
Copyright: GPL
Source: MAKEDEV-%{version}-%{rhrelease}.tar.bz2
Patch0: MAKEDEV-3.2-mdkconf.patch.bz2
Summary: A program used for creating the device files in /dev.
BuildRoot: %{_tmppath}/%{name}-root

%description
This package contains the MAKEDEV script, which makes it easier to create
and maintain the files in the /dev directory.  /dev directory files
correspond to a particular device supported by Linux (serial or printer
ports, scanners, sound cards, tape drives, CD-ROM drives, hard drives,
etc.) and interface with the drivers in the kernel.

You should install the MAKEDEV package because the MAKEDEV utility makes
it easy to manage the /dev directory device files.

%package -n dev
Group: System/Kernel and hardware
Summary: The most commonly-used entries in the /dev directory.
Prereq: /usr/sbin/groupadd, /bin/mkdir, sed, textutils, fileutils, mktemp

%description -n dev
The Linux Mandrake operating system uses file system entries to represent
devices (CD-ROMs, floppy drives, etc.) attached to the machine. All of
these entries are in the /dev tree (although they don't have to be).
This package contains the most commonly used /dev entries.

The dev package is a basic part of your Linux-Mandrake system and it needs
to be installed.

%prep
%setup -q
%patch -p1 -b %{extpatch}

%build
#find . -name '*%{extpatch}'|xargs rm -f
make OPTFLAGS="$RPM_OPT_FLAGS"

%install
mkdev() {
	$RPM_BUILD_ROOT/dev/MAKEDEV -c $RPM_BUILD_ROOT%{_sysconfdir}/makedev.d -d $RPM_BUILD_ROOT/dev $@
}
makedev() {
	if [ `id -u` = 0 ] ; then
		# Note that we need to be the superuser for this to work at all.
		mkdev $@
	else
		# Note that we need RPM 4.0.3-0.71 or higher for this to be of any use!
		mkdev -M $@ | sed "s|$RPM_BUILD_ROOT||g" >> manifest
	fi
}

rm -fr $RPM_BUILD_ROOT manifest

%ifarch s390 s390x
export S390=1
%endif
%makeinstall devdir=$RPM_BUILD_ROOT/dev
install -d $RPM_BUILD_ROOT/sbin
mv -f $RPM_BUILD_ROOT/dev/MAKEDEV $RPM_BUILD_ROOT/sbin
ln -s ../sbin/MAKEDEV $RPM_BUILD_ROOT/dev/MAKEDEV

%ifnarch s390 s390x
makedev agpgart
makedev apm_bios
makedev beep
makedev capi20
makedev cdrom
%endif

makedev -m 32 console

%ifnarch s390 s390x
makedev -m 4 cua
makedev -m 16 cui
makedev enskip
makedev fb
makedev fd0
makedev fd1
makedev ftape
makedev -m 2 ht
makedev -m 2 i2c
makedev i2o
makedev ibcs
makedev -m 17 ide
%endif

makedev initrd

%ifnarch s390 s390x
makedev -m 32 input
makedev -m 16 ip
%endif

makedev -m 16 ipfilter

%ifnarch s390 s390x
makedev ir
makedev -m 2 iscc
makedev -m 16 isdn
makedev -m 4 js
%endif

makedev -m 32 loop
makedev -m 1 log

%ifnarch s390 s390x
makedev -m 8 lp
%endif

makedev md

%ifnarch s390 s390x
makedev mouse
%endif

makedev -m 32 nb

%ifnarch s390 s390x
makedev netlink
makedev -m 2 nht
makedev -m 16 nst
makedev -m 4 osst
makedev -m 8 par
makedev -m 4 pcd
makedev pd
makedev -m 4 pf
makedev -m 4 pg
makedev -m 4 ppp
makedev pt
%endif

makedev ptmx
makedev pty

%ifnarch s390 s390x
makedev qng
%endif

makedev -m 20 ram
makedev random

%ifnarch s390 s390x
makedev raid
%endif

makedev raw

%ifnarch s390 s390x
makedev rmt
makedev rtc
makedev -m 8 scd
makedev sd
makedev -m 16 sg
makedev smpt
makedev sound
makedev -m 16 st
%endif

makedev systty

#MDK
makedev nb
makedev ixj
makedev isdn
makedev cui
makedev dac960
makedev alsa
makedev mandrake
makedev microcode
makedev ppp
makedev shm
%ifarch ppc
makedev -m 56 adb
%endif    
makedev nvidia
#MDK

%ifnarch s390 s390x
makedev -m 4 staliomem
%endif

makedev std

%ifnarch s390 s390x
makedev tlk
%endif

makedev -m 32 tty
makedev urandom

%ifnarch s390 s390x
makedev -m 32 usb
makedev -m 4 v4l
makedev vcs
makedev vmmon
makedev -m 4 vnet
makedev -m 4 winradio
makedev xda
makedev xdb
%endif

# Create architecture-specific devices.
%ifarch s390 s390x
makedev dasd
makedev mnd
makedev xpram
rm -f $RPM_BUILD_ROOT/dev/fd[0-7]*
rm -f $RPM_BUILD_ROOT/dev/vcs*
if [ -f manifest ] ; then
	grep -v '/dev/fd[0-7]' manifest > manifest.tmp && mv manifest.tmp manifest
	grep -v '/dev/vcs'     manifest > manifest.tmp && mv manifest.tmp manifest
fi
%endif

%ifarch ia64
makedev efirtc
%endif

%ifarch sparc sparc64
makedev audioctl
makedev kbd
makedev openprom
ln -s sunmouse $RPM_BUILD_ROOT/dev/mouse
for dev in aztcd cdu31a cdu535 cm205cd cm206cd gscd hitcd mcd mcdx \
	sbpcd1 sbpcd2 scd3 sjcd sbpcd3 sonycd sbpcd sbpcd0 \
	atibm inportbm logibm ; do
	rm -f $RPM_BUILD_ROOT/dev/${dev}
done
%endif

# If we're using a version of RPM which can't handle devices yet,
# generate a manifest using /dev.
if [ ! -f manifest ] ; then
	find $RPM_BUILD_ROOT/dev -maxdepth 1 -mindepth 1 -not -name MAKEDEV -and -not -name log | \
	sed -e "s|$RPM_BUILD_ROOT||g" > manifest
fi
grep -v '/dev/log$' manifest | sort -u > mdmanifest

# Make subdirectories we otherwise would have nothing to do with.
install -d -m 755 $RPM_BUILD_ROOT/dev/pts
install -d -m 755 $RPM_BUILD_ROOT/dev/shm

%clean
rm -fr $RPM_BUILD_ROOT

%pre
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the %{name} package: mounted devfs detected."
		exit $MOUNTED
	fi
fi

%pre -n dev
if [ -r /proc/mounts ] ; then
	(while read source mountpoint rest ; do
		if [ "$mountpoint" = /dev ] ; then
			exit 1
		fi
	 done
	 exit 0 ) < /proc/mounts
	MOUNTED=$?
	if [ "$MOUNTED" -ne 0 ] ; then
		echo $"Cannot install the dev package: mounted devfs detected."
		exit $MOUNTED
	fi
fi
if [ ! -d /dev ] ; then
	/bin/mkdir /dev
fi
/usr/sbin/groupadd -g 19 -r -f floppy > /dev/null 2>/dev/null ||:
exit 0

%post -n dev
%ifnarch s390 s390x
if [ -f /etc/fstab ] ; then
  # add /dev/pts to fstab if fstab exists (install2 does it during install)
  if grep 'devpts' /etc/fstab >/dev/null 2>&1 ; then 
      # correct permissions from broken dev packages
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed 's/devpts.*mode=0622/devpts  gid=5,mode=620/g' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to correct devpts permissions in /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
  else
    # note that we do not disallow comments; we wish to allow people
    # to comment it out if they so desire.
    if [ $(grep '/proc' /dev/fstab 2>/dev/null | wc -l) -gt 1 ] ; then
      # ugly but robust
      echo '
none                    /dev/pts                devpts  gid=5,mode=620        0 0' \
        >> /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
    else
      # beautiful in the common case
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed '/\/proc/a\
none                    /dev/pts                devpts  gid=5,mode=620        0 0
          ' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to add devpts filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
    fi
  fi
  # add /dev/shm to fstab if fstab exists (install2 does it during install)
  if ! grep 'tmpfs' /etc/fstab >/dev/null 2>&1 ; then 
    # note that we do not disallow comments; we wish to allow people
    # to comment it out if they so desire.
    if [ $(grep '/proc' /dev/fstab 2>/dev/null | wc -l) -gt 1 ] ; then
      # ugly but robust
      echo '
none                    /dev/shm                tmpfs   defaults        0 0' \
        >> /etc/fstab || { echo "failed to add tmpfs filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
    else
      # beautiful in the common case
      TMP=$(mktemp /tmp/fstab.XXXXXX)
      sed '/\/proc/a\
none                    /dev/shm                tmpfs   defaults        0 0
          ' < /etc/fstab > $TMP && cat $TMP > /etc/fstab || { echo "failed to add tmpfs filesystem to /etc/fstab" 1>&2 ; exit 1 ; }
      rm -f $TMP
    fi
  fi
fi
%endif
if [ -x /sbin/pam_console_apply ] ; then
  /sbin/pam_console_apply
fi

%files
%defattr(-,root,root)
%doc COPYING
/sbin/MAKEDEV
/dev/MAKEDEV
%{_mandir}/man8/*
%{_sbindir}/mksock
%config(noreplace) %{_sysconfdir}/makedev.d/*

%files -n dev -f mdmanifest
%defattr(-,root,root)
%dir /dev
%ghost /dev/log
%dir /dev/pts
%dir /dev/shm

%changelog
* Thu Aug 30 2001 Pixel <pixel@mandrakesoft.com> 3.2-3mdk
- move MAKEDEV to /sbin (symlink kept for compatibility)

* Tue Aug  7 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.2-2mdk
- Rebuild as root or rpm screwd up.
- Fix file lists.

* Mon Aug  6 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.2-1mdk
- Add hiddev.
- 3.2.

* Mon Jun 25 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.1-1mdk
- 3.1.1 (big upgrade may screw up thing).

* Mon Apr 30 2001 Frederic Lepied <flepied@mandrakesoft.com> 3.0.6-10mdk
- call pam_console_apply in %post to restore the owner of the devices
after an upgrade.

* Sat Apr 14 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-9mdk
- Add nvidia.

* Thu Mar  8 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-8mdk
- For ppc create adb devices (stew).

* Tue Mar  6 2001 Pixel <pixel@mandrakesoft.com> 3.0.6-7mdk
- fix for /dev/rd/c*d*p8 which doesn't exist
- add cciss

* Thu Feb 22 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-6mdk
- add sheep_net entry.

* Wed Jan 17 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-5mdk
- Add shm directorie.
- Add more generated device.
- Upgrade to -8 release of rh.

* Tue Nov 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-4mdk
- Put config files as noreplace.

* Wed Nov 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-3mdk
- Add toshiba devices.
- Upgrade to -7 release of rh.

* Wed Sep 27 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-2mdk
- Make pg* as cdwriter group (thanks till).

* Wed Aug 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.6-1mdk
- add an rm -f $TMP in %%post (pixel).
- Correct alsa link.
- Merge with RH 3.0.6

* Mon Jul 31 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.2-5mdk
- Correct usbmouse link to input/mouse0.

* Wed Jul 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.2-4mdk
- Create ppp devices.

* Tue Jul 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.2-3mdk
- Don't remove isdnctl (remove it from the isdn package instead).
- Correct micrcode in the right way (titi sucks).

* Tue Jul 25 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 3.0.2-2mdk
- remove RH microcode entry and reput the entires i add to dev before
  lord chmoue destroy it : cpu/{mircrocode,?/{cpuid,msr} for 2cpuid,msr} for
  2.4.x
- remove also conflicting /dev/isdnctrl

* Mon Jul 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.0.2-1mdk
- Mandrake adaptation of the new dev system.
- Merge dev system of Red Hat.
- Merge MAKEDEV and dev package.

